// problem 10187
// ID 60787HM
import java.io.*;

class Connection {
	Station target;
	int from, time;
	Connection next;
	
	public Connection(Station target, int from, int time, Connection next) {
		this.target = target;
		this.from = from;
		this.time = time;
		this.next = next;
	}
}

class Station {
	String name;
	Connection connections;
	int duration;
	Station next;
	
	public Station(String name, Station next) {
		this.name = name;
		duration = Integer.MAX_VALUE;
		this.next = next;
		connections = null;
	}
}

class Main {
	static InputStream is = System.in;
	static final int BUF_SIZE = 2048;
	static String buf = null;
	static int bl = 0;
	static int gap = -1;
	static int eol = -1;
	static int pos = -1;
	static Station stations, from, to;
	static int ltrs;
	
	private static void fillBuf() {
		try { 
			byte[] a = new byte[BUF_SIZE];
			bl = is.read(a, 0, BUF_SIZE);
			buf = new String(a, 0, bl);
			bl = buf.length();
			pos = 0;
			gap = -1;
			eol = -1;
		}
		catch (Exception e) {
			bl = 0;
		}
	}
	
	private static String inStr() {
		String s = "";
		int n = -2;
		if (buf == null) fillBuf();
		while (((n < 0) || (n >= bl)) && (bl > 0)) {
			if ((pos < 0) || (pos >= bl)) fillBuf();
			if (pos > gap) gap = buf.indexOf(32, pos);
			if (pos > eol) eol = buf.indexOf(10, pos);
			if ((eol >= 0) && ((eol < gap) || (gap < 0))) n = eol;
			else n = gap;
			if (n < 0) {
				if (bl > 0) n = bl;
				else return null;
			}
			s += buf.substring(pos, n);
			pos = n+1;
		}
		return s.trim();
	} 

	private static Station find(String name) {
		Station p = stations;
		while ((p != null) && (!p.name.equals(name)))
			p = p.next;
		return p;
	}

	private static Station add(String name) {
		Station p = find(name);
		if (p == null) return stations = new Station(name, stations);
		return p;
	}
	
	private static void addConnection() {
		Station s1 = add(Main.inStr());
		Station s2 = add(Main.inStr());
		int tFrom = Integer.parseInt(Main.inStr()) % 24;
		int tTime = Integer.parseInt(Main.inStr());
		if (((tFrom < 18) && (tFrom >= 6))
			|| ((((tFrom + tTime) % 24) > 6) && (((tFrom + tTime) % 24) < 19))
			|| (tTime > 12)) return;
		s1.connections = new Connection(s2, tFrom, tTime, s1.connections);
	}

	private static void outln(String s) {
		System.out.print(s + "\n");
	}
	
	private static void inputTest() {
		int n = Integer.parseInt(inStr());
		for (int i = 1; i <= n; i++) addConnection();
		from = find(inStr());
		to = find(inStr());
	}

	private static void search(Station st, int time,
			int duration, int litres) {
		if ((st.duration <= duration) && (time != Integer.MAX_VALUE)) return;
		if (time == Integer.MAX_VALUE) {
			st.duration = 0;
		} else {
			st.duration = duration;
		}
		if (st == to) {
			ltrs = litres;
			return;
		}
		Connection c = st.connections;
		while (c != null){
			if (time == Integer.MAX_VALUE) search(c.target, c.from + c.time, c.time, 0);
			else {
				int delta = 0;
				int t = time;
				int l = litres;
				if ((t % 24) > c.from) {
					delta = 24 - (t % 24);
					t += delta;
				}
				delta += c.from - (t % 24);
				t += c.from - (t % 24);
				if (delta > 11) {
					l++;
				}
				search(c.target, t + c.time, duration + delta + c.time, l);
			}
			c = c.next;
		}
	}
	
	private static void solve() {
		ltrs = -1;
		if ((from != null) && (to != null))
			search(from, Integer.MAX_VALUE, 0, 0);
		if (ltrs >= 0)
			outln("Vladimir needs "
					+ ltrs + " litre(s) of blood.");
		else
			outln("There is no route Vladimir can take.");
	}

	public static void main(String[] args) {
/*
		try {
			is = new FileInputStream("C:\\eclipse\\workspace\\Vladimir\\dusk.in");
		} catch(Exception e) {
		}
//*/
		int n = Integer.parseInt(inStr());
		for (int i = 1; i <= n; i++) {
			from = null;
			to = null;
			stations = null;
			inputTest();
			outln("Test Case " + i + ".");
			solve();
		}
	}
}